////////////////////////////////////////////////////////////////////
//
//  cmbRicorrenzeDataSource.h
//  Tutorial uso di MySql con driver ODBC della actual technologies
//
//  Created by Francesco Germinara 
// 
//  Freeware (c) 2005 SofTech di F.Germinara - www.germinara.it. 
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////

#import "cmbRicorrenzeDataSource.h"


@implementation cmbRicorrenzeDataSource

-(id) init
{
	items=[[NSMutableArray alloc] init];
	keys=[[NSMutableArray alloc] init];
	nIndex=0;
	return (self);
}

-(void)dealloc{
 [items release];
 [keys release];
 nIndex=0;
 [super dealloc];
}

-(void) AddItem:(NSString *) item forKey:(NSString*) key{
	
	int bNew=[self searchForKey:key];
	if(bNew==-1){//Not found, then insert a new element
	 [items insertObject:item atIndex:nIndex];
	 [keys insertObject:key atIndex:nIndex];
	 nIndex++;
	}
}

-(int) searchForKey:(NSString *)key{
	int nPos=0;
	for(nPos=0; nPos<nIndex;nPos++){
	 if([[keys objectAtIndex:nPos] isEqualToString:key])
		 return nPos;	  
	}
	return -1; //not found
}

- (int)numberOfItemsInComboBox:(NSComboBox *)aComboBox{
	
	return [items count];
}

- (id)comboBox:(NSComboBox *)aComboBox objectValueForItemAtIndex:(int)index{
    return [items objectAtIndex:index];
}

//Esecute Query
-(void)FillArray:(FGODBCRecord *)tabella SqlFilter:(NSString *) strFilter strKey:(NSString*) strKeyName strItem:(NSString*) strItemName{
	[items removeAllObjects]; 	
	[keys removeAllObjects]; 
	nIndex=0;
	[self AddItem:@"No matters"  forKey:@"0000"];
	
	//Query data ...
	int sts=0;
	
	sts=[tabella OpenQuery:strFilter];
	while(sts==TRUE){
		FGODBCRecord *tmpRecord;	
		tmpRecord=[[FGODBCRecord alloc]initWithRecordData:tabella];
		[self AddItem:[[tmpRecord FieldInfo:strItemName] GetValue] forKey:[[tmpRecord FieldInfo:strKeyName ] GetValue]];
[tmpRecord release];	
sts=[tabella MoveNext];
	}
[tabella CloseQuery];
}


//Return Single Field data row
-(NSString *) GetkeyAtRow:(int) row{
	NSString *strResult=nil;
	strResult=[keys objectAtIndex:row];
	return strResult;		
}


@end
